
public class Circle_v2
{
   public static void main(String[] args)
   {
       Point p = new Point(-1, -1);
       Circle c2 = new Circle(6, p); // Draw a picture of what this constructs!
       c2.writeOutput();
       p.setX(100);       // Move the circle without its "permission".
       c2.writeOutput();
   }
}


/**
    This class models points in the plane.

    It is used for the center of our circles.
*/
class Point
{
   private double x;
   private double y;
   public Point(double newX, double newY)
   {
      x = newX;
      y = newY;
   }
   public void setX(double newX)
   {
      x = newX;
   }
   public void setY(double newY)
   {
      y = newY;
   }
   public double getX()
   {
      return x;
   }
   double getY()
   {
      return y;
   }
}// Point


/**
    This class models circles in the plane.
*/
class Circle
{
   // Declare two instance variables for a Circle object.
   // Make them private instance variables.
 //private double xCenter;
 //private double yCenter;
   private Point center;
   private double radius;

   /**
       Define a constructor for initializing this circle's instance variables.
   */
   public Circle(double r, Point c)
   {
    //xCenter = x;
    //yCenter = y;
      center = c;  // what should we do about a null center?
      radius = r;  // what should we do about a negative radius?
      if ( radius < 0 )
         throw new Error("radius is negtative");
      if (center == null)
        throw new Error("center is missing");
   }

   /**
       Define a constructor for initializing this circle's instance variables.
   */
   public Circle(double r)
   {
    //xCenter = 0;  // default value
    //yCenter = 0;  // default value
      center = new Point(0, 0);  // default value
      radius = r;  // what should we do about a negative radius?
      if ( radius < 0 )
         throw new Error("radius is negtative");
   }

   /**
       An accessor method to return the radius.
   */
   public double getRadius()
   {
      return radius;
   }

   /**
       An accessor method to return the x-value of the center.
   */
   public double getX()
   {
      return center.getX();
   }

   /**
       An accessor method to return the y-value of the center.
   */
   public double getY()
   {
      return center.getY();
   }

   /**
       A method to compute this circle's area.
   */
   public double computeArea()
   {
      return Math.PI*Math.pow(radius,2);
   }

   /**
       A method to compute this cirlcle's perimeter.
   */
   public double computePerimeter()
   {
      return 2*Math.PI*radius;
   }

   /**
       A mutator method to move this circle to a new location.
   */
   public void moveTo(double x, double y)
   {
    //xCenter = x;
    //yCenter = y;
      center.setX(x);
      center.setY(y);
   }

   /**
       A mutator method to move this circle to a new location.
   */
   public void moveTo(Point p)
   {
      center.setX(p.getX());
      center.setY(p.getY());
   }

   /**
       A mutator method to move this circle by a given amount.
   */
   public void moveBy(double x, double y)
   {
    //xCenter = xCenter + x;
    //yCenter = yCenter + y;
      center.setX( x + center.getX() );
      center.setY( y + center.getY() );
   }

   /**
       A mutator method to move this circle up (or down) from
       where it currently is.
   */
   public void moveUp(double distance)
   {
    //xCenter += distance;
      center.setX( distance + center.getX() );
   }

   /**
       A mutator method to move this circle right (or left) from
       where it currently is.
   */
   public void moveRight(double distance)
   {
    //yCenter += distance;
      center.setY( distance + center.getY() );
   }

   /**
       A mutator method to grow (or shrink) this circle.

       Precondition: radius >= 0.
   */
   public void growBy(double perCentChange)
   {
      radius += perCentChange * radius;
      //if ( radius < 0 )
      //   throw new Error("radius is negtative");
   }

   /**
       A mutator method to grow (or shrink) this circle.
   */
   public void growTo(double r)
   {
      radius = r;  // what about a possible negative radius?
      if ( radius < 0 )
         throw new Error("radius is negtative");
   }

   /**
       A method to determine if this circle
       intersects (overlaps) another circle.
   */
   public boolean intersect(Circle circle2)
   {
      // compute the distance between the centers
      double deltaX = this.center.getX() - circle2.getX();
      double deltaY = this.center.getY() - circle2.getY();
      double distance = Math.sqrt( deltaX*deltaX + deltaY*deltaY );

      return ( distance < (this.radius + circle2.radius) );
   }

   /**
       A method to determine if this circle
       is equal to another circle.
   */
   public boolean equals(Circle circle2)
   {
      return ( (this.center.getX() == circle2.getX())
            && (this.center.getY() == circle2.getY())
            && (this.radius  == circle2.radius  ));
   }

   /**
       A method to print out this Circle object's data.
   */
   public void writeOutput()
   {
      System.out.println("This circle has the following properties:");
      System.out.println("\tcenter = (" + center.getX() + "," + center.getY() + ")" );
      System.out.println("\tradius  = " + radius);
   }

}// Circle
