/*
   Fix the "privacy leak" in the Circle constructor.
*/

public class Circle_v4
{
   public static void main(String[] args)
   {
       Point p = new Point(-1, -1);
       Circle c2 = new Circle(6, p); // Draw a picture of what this constructs!
       c2.writeOutput();
       p.setX(100);      // This will not move our circle.
       c2.writeOutput();
   }
}


class Point
{
   private double x;
   private double y;
   public Point(double newX, double newY)
   {
      x = newX;
      y = newY;
   }
   public void setX(double newX)
   {
      x = newX;
   }
   public void setY(double newY)
   {
      y = newY;
   }
   public double getX()
   {
      return x;
   }
   double getY()
   {
      return y;
   }
}// Point


class Circle
{
   private Point center;
   private double radius;

   public Circle(double r, Point c)
   {
      if (c == null)
        throw new Error("center is missing");
      center = new Point(c.getX(), c.getY());
      radius = r;
      if ( radius < 0 )
         throw new Error("radius is negtative");
   }

   public Circle(double r)
   {
     center = new Point(0, 0);
      radius = r;
      if ( radius < 0 )
         throw new Error("radius is negtative");
   }

   public double getRadius()
   {
      return radius;
   }

   public double getX()
   {
      return center.getX();
   }

   public double getY()
   {
      return center.getY();
   }

   public double computeArea()
   {
      return Math.PI*Math.pow(radius,2);
   }

   public void moveTo(double x, double y)
   {
     center.setX(x);
     center.setY(y);
   }

   public void moveTo(Point p)
   {
      center.setX(p.getX());
      center.setY(p.getY());
   }

   public void moveBy(double x, double y)
   {
      center.setX( x + center.getX() );
      center.setY( y + center.getY() );
   }

   public void writeOutput()
   {
      System.out.println("This circle has the following properties:");
      System.out.println("\tcenter = (" + center.getX() + "," + center.getY() + ")" );
      System.out.println("\tradius  = " + radius);
   }
}// Circle
